PROGRAM create_mx_scripts;

VAR  ouf,batch                   : text;
     ny,nx,
     nd,nm,ns,
     neta,nksi,
     i,j,k                       : integer;
     measurement,stratification,
     familyvariables,measurementX,fammean,
     BETA,
     gAlpha,gBETA,gGAMMA,gPSI,gNU,gLAMBDA,gTheta,
     sAlpha,sBETA,sGAMMA,sPSI,sNU,sLAMBDA,sTheta
                                 : string[1];
     outname,datname,batchname   : string[12];
     A1,A2,A3,B1,B2,B3,G1,G2,G3,P1,P2,P3,
     N1,N2,N3,L1,L2,L3,T1,T2,T3,
     C1,
     t4,P4,o4,K4,D4,
     Ie,Ik,Iy,St                 : string[1];
     defvar                      : ARRAY[1..20] of string[1];
     a,B,Bt,G,P,v,L,Lt,T,C,
     Syx,Sxy                     : ARRAY[1..20] of string;
     tau,Ph,Om,Ka,De,Sx          : string;

{PROCEDURE questions;
PROCEDURE readbatch;
PROCEDURE feedback;
PROCEDURE letter2matrix;
PROCEDURE group1_3;
PROCEDURE group4;
PROCEDURE datagroup;
Function FileExists (filename : string) : boolean ; }

Function FileExists (filename : string) : boolean ;
  Var
   f      : text   ;
   IOCode : integer;
  Begin
   {$I-}
   assign(f,filename);
   Reset(f);
   IOCode := IOResult;
   if IOCode <> 0 then
    begin
    writeln;
    writeln('the file "',filename,'" does not exist!');
    writeln;
    end;
   Close(f);
   {$I+}
  end;


PROCEDURE questions;
Begin
    writeln;
    writeln('  FIRST SOME QUESTIONS ABOUT YOUR DATA');
    writeln;
    writeln('Are there multiple indicators for one of the subject (=y) variables?');
    writeln(' measurement part subject variables');
    write(' (type lower case y (= yes) or n (= no) then press <ENTER>): ');
    readln(measurement);
    if measurement = 'y' then
      begin
       write('Enter number of (latent) subject variables: ');
       readln(neta);
       write('Enter total number of indicators for latent subject variables: ');
       readln(ny);
      end;
    if measurement <> 'y' then
      begin
       write('Enter number of subject = indicator variables: ');
       readln(neta);
       ny := neta ;
       end;
    write('Enter number of subjects in largest family: '); readln(ns);
    if ns > 1 then
    BEGIN
    writeln('Are there variables (=x) that are identical for all subjects in the family?');
    write(' family variables? (y/n): '); readln(familyvariables);
    if familyvariables = 'y' then
     begin
      writeln('Are there multiple indicators for one of the family variables?');
      write(' measurement part family variables (y/n): ');
      readln(measurementx);
      if measurementx = 'y' then
        begin
         write('Enter number of (latent) family variables: ');
         readln(nksi);
         write('Enter total number of indicators for latent family variables: ');
         readln(nx);
        end;
      if measurementx <> 'y' then
        begin
         write('Enter number of family = indicator variables: ');
         readln(nksi);
         nx := nksi ;
         end;
      end;
    END;
    write('Enter number of dummy variables for genotypes: '); readln(nd);
    write('Do you want to specify stratification effects? (y/n): '); readln(stratification);
    if (stratification = 'y') then
     begin
      write('Enter number of dummy variables for family types: ');
      readln(nm);
     end;
    writeln;
    writeln('  WHICH OF THE FOLLOWING (OPTIONAL) MATRICES DO YOU WANT TO USE?');
    writeln;
    if neta > 1 then
      begin
        writeln('-OVERALL MODEL-');
        writeln('Do the subject variables have causal effects on each other?');
        write(' matrix type BETA? (y/n): '); readln(BETA);
      end;
    if familyvariables = 'y' then
      begin
        if neta <= 1 then writeln('-OVERALL MODEL-');
        writeln('Do you want the mean of the family variable(s) to have an effect on the subject variables?');
        write(' matrix type TAU? (y/n): '); readln(fammean);
      end;
    writeln;
    writeln('-GENETIC EFFECTS-');
    writeln('GENETIC effects on means of subject variables?');
         write(' matrix type ALPHA? (y/n): '); readln(gAlpha);
    if (BETA = 'y') then
      begin writeln('GENETIC effects on causal relations between subject variables?');
            write(' matrix type BETA? (y/n): ');  readln(gBETA);
      end;
    if (familyvariables = 'y') then
      begin writeln('GENETIC effects on causal effect of family on subject variables?');
            write(' matrix type GAMMA? (y/n): ');  readln(gGAMMA);
      end;
     writeln('GENETIC effects on residual (co)variances of subject variables?');
       write(' matrix type Psi? (y/n): '); readln(gPSI);
if (measurement = 'y') or (measurement = 'Y') then
 begin
    writeln('GENETIC effects on intercepts of subject indicator variables?'); write(' matrix type NU? (y/n): '); readln(gNU);
    writeln('GENETIC effects on (factor) loadings of subject indicator variables?');
     write(' matrix type LAMBDA(y)? (y/n): ');
          readln(gLAMBDA);
    writeln('GENETIC effects on measurement errors subject indicator variables?');
     write(' matrix type Theta? (y/n): '); readln(gTheta);
 end;
if (stratification = 'y') then
 Begin
    writeln;
    writeln('-STRATIFICATION EFFECTS-');

    if (gALPHA = 'y') then
     begin
      writeln('STRATIFICATION effects on means of subject variables?');
      write(' matrix type ALPHA? (y/n): '); readln(sAlpha);
     end;

    if (gBETA = 'y') then
     begin
      writeln('STRATIFICATION effects on the causal relations between subject variables?');
      write(' matrix type BETA? (y/n): ');  readln(sBETA);
    end;

    if (gGAMMA = 'y') then
      begin
       writeln('STRATIFICATION effects on the causal effects of family on subject variables?');
       write(' matrix type GAMMA? (y/n): '); readln(sGAMMA);
      end;

    if (gPSI = 'y') then
      begin
       writeln('STRATIFICATION effects on residual (co)variances of subject variables?');
       write(' matrix type Psi? (y/n): '); readln(sPSI);
      end;

    if (gNU = 'y') then
      begin
       writeln('STRATIFICATION effects on intercepts of subject indicator variables?');
       write(' matrix type Nu? (y/n): '); readln(sNU);
      end;

    if (gLAMBDA = 'y') then
      begin
       writeln('STRATIFICATION effects on (factor) loadings of subject indicator variables');
       write(' matrix type LAMBDA(y)? (y/n): ');  readln(sLAMBDA);
      end;

    if (gTheta = 'y') then
      begin
       writeln('STRATIFICATION effects on measurement errors subject indiator variables');
       write(' matrix type Theta? (y/n): '); readln(sTheta);
      end;
 End;
 writeln;
 writeln('Name of file with your data?');
 write('DOS name <max 8 letters><dot><extension max 3 letters>: '); readln(datname);
 writeln;
 write('Name of the file for the Mx script?  '); readln(outname);
 writeln;

End;


PROCEDURE readbatch;
Begin
    readln(batch);
    readln(batch,measurement);
    if measurement = 'y' then
      BEGIN
        readln(batch,neta);
        readln(batch,ny);
      END else BEGIN readln(batch,neta); ny:=neta; readln(batch); END;
    readln(batch,ns);
    if ns > 1 then
    BEGIN
     readln(batch,familyvariables);
     if familyvariables = 'y' then
       Begin
         readln(batch,measurementx);
         if measurementx = 'y' then
           begin
            readln(batch,nksi);
            readln(batch,nx);
           end else begin readln(batch,nksi); nx:=nksi; readln(batch); end;
        End else Begin readln(batch); readln(batch); readln(batch); End;
     END else BEGIN readln(batch); readln(batch); readln(batch); readln(batch); END;
    readln(batch,nd);
    readln(batch,stratification);
    if (stratification = 'y') then readln(batch,nm) else readln(batch);
    if neta > 1 then readln(batch,BETA) else readln(batch);
    if familyvariables = 'y' then readln(batch,fammean) else readln(batch);
    readln(batch,gAlpha);
    if (BETA = 'y') then readln(batch,gBETA) else readln(batch);
    if (familyvariables = 'y') then readln(batch,gGAMMA) else readln(batch);
    readln(batch,gPSI);

    if (measurement = 'y') then
     BEGIN
       readln(batch,gNU); 
       readln(batch,gLAMBDA); 
       readln(batch,gTheta); 
     END else begin readln(batch); readln(batch); readln(batch); end;
    
     if (stratification = 'y') then
      BEGIN
       if (gAlpha = 'y') then readln(batch,sAlpha) else readln(batch);
       if (gBETA  = 'y') then readln(batch,sBETA) else readln(batch);
       if (gGAMMA = 'y') then readln(batch,sGAMMA) else readln(batch);
       if (gPSI   = 'y') then readln(batch,sPSI) else readln(batch);
       if (gNU  = 'y') then readln(batch,sNU) else readln(batch);
       if (gLAMBDA = 'y') then readln(batch,sLAMBDA) else readln(batch);
       if (gTheta   = 'y') then readln(batch,sTheta) else readln(batch);
       END else BEGIN
                   readln(batch); readln(batch); readln(batch); readln(batch); 
                   readln(batch); readln(batch); readln(batch);
                 END;
    readln(batch);
    readln(batch,datname);
    readln(batch);
    readln(batch,outname);
    writeln;
End;




PROCEDURE letter2matrix;

Var
     last,
     nA1,nA2,nA3,nB1,nB2,nB3,nG1,nG2,nG3,nP1,nP2,nP3,
     nN1,nN2,nN3,nL1,nL2,nL3,nT1,nT2,nT3,
     nC1,
     nt4,nP4,no4,nK4,nD4,
     nIe,nIk,nIy,nSt             : integer;
     letused                     : ARRAY[1..26,1..2] of string[1];

Begin
     last := 1;
                                  nA1 := last; inc(last);
     if (gALPHA = 'y') then begin nA2 := last; inc(last); end; 
     if (sALPHA = 'y') then begin nA3 := last; inc(last); end; 

     if (BETA = 'y')  then  begin nB1 := last; inc(last); end; 
     if (gBETA = 'y') then  begin nB2 := last; inc(last); end; 
     if (sBETA = 'y') then  begin nB3 := last; inc(last); end; 

     if (familyvariables = 'y')
                       then begin nG1 := last; inc(last); end;
     if (gGAMMA = 'y') then begin nG2 := last; inc(last); end;
     if (sGAMMA = 'y') then begin nG3 := last; inc(last); end;

                                  nP1 := last; inc(last);
     if (gPSI = 'y')   then begin nP2 := last; inc(last); end;
     if (sPSI = 'y')   then begin nP3 := last; inc(last); end;
 
    

     if (measurement = 'y')
                       then begin nN1 := last; inc(last); end;
     if (gNU = 'y')    then begin nN2 := last; inc(last); end;
     if (sNU = 'y')    then begin nN3 := last; inc(last); end;

     if (measurement = 'y')
                        then begin nL1 := last; inc(last); end;
     if (gLAMBDA = 'y') then begin nL2 := last; inc(last); end;
     if (sLAMBDA = 'y') then begin nL3 := last; inc(last); end;

     if (measurement = 'y')
                        then begin nT1 := last; inc(last); end;
     if (gTHETA = 'y')  then begin nT2 := last; inc(last); end;
     if (sTHETA = 'y')  then begin nT3 := last; inc(last); end;

     if (ns > 1)       then   begin nC1 := last; inc(last); end;

     if (familyvariables = 'y')
                       then   begin nt4 := last; inc(last); end;

     if (familyvariables = 'y')
                       then   begin nP4 := last; inc(last); end;

     if (familyvariables = 'y')
                       then   begin no4 := last; inc(last); end;

     if (measurementx = 'y')
                         then begin nK4 := last; inc(last); end;

     if (measurementx = 'y')
                        then begin nD4 := last; inc(last); end;

     if (neta > 1) and
        ((BETA = 'y') or (gPSI='y') or (sPSI='y') or
        (gLAMBDA= 'y') or (sLAMBDA= 'y')) then
                              begin nIe := last; inc(last); end;

     if (nksi > 1) and
        ((gGAMMA = 'y') or (sGAMMA='y')) then
                              begin nIk := last; inc(last); end;

     if  (sTheta = 'y') or (gTheta = 'y') then
         begin
           if (measurement = 'y') and (ny > 1) then begin nIy := last; inc(last); end;
           if (measurement <> 'y') and (neta > 1) then nIy := nIe;
         end;

     if (stratification = 'y')  then
                              begin nSt := last; inc(last); end;
  if ((last + ns -1) > 26) then
   begin
     writeln;
     writeln('  The number of matrices                               = ',last-2);
     writeln('  The number of vectors for subjects in largest family =  ',ns);
     writeln('  The vector for the family type variables             =  ',1);
     writeln('                                                      ---');
     writeln('                                                TOTAL  = ',last+ns-1);
     writeln;
     write(' Mx cannot handle more than 26 matrices. ');
     write('Reduce number of matrices. ');
     write('For example, stack the matrices in group 1 and 2 horizontally or ');
     write('fit a model that conditions (=uses as definition variables) on the independent variables.');
     writeln;
     outname := 'dump.mx';
     writeln('  script is written to file "',outname,'"');
     writeln;
   end else writeln('FINISHED...Mx script is written to file "',outname,'"');


  for i:=1 to 26 do letused[i,2] := 'n';
  letused[1,1]  := 'a';   letused[2,1]  := 'b';  letused[3,1]  := 'c';   letused[4,1]  := 'd';
  letused[5,1]  := 'e';   letused[6,1]  := 'f';  letused[7,1]  := 'g';   letused[8,1]  := 'h';
  letused[9,1]  := 'i';   letused[10,1] := 'j';  letused[11,1] := 'k';   letused[12,1] := 'l';
  letused[13,1] := 'm';   letused[14,1] := 'n';  letused[15,1] := 'o';   letused[16,1] := 'p';
  letused[17,1] := 'q';   letused[18,1] := 'r';  letused[19,1] := 's';   letused[20,1] := 't';
  letused[21,1] := 'u';   letused[22,1] := 'v';  letused[23,1] := 'w';   letused[24,1] := 'x';
  letused[25,1] := 'y';   letused[26,1] := 'z';

  for i:=1 to 26 do if i = nA1 then
                       begin A1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nA2 then
                       begin A2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nA3 then
                       begin A3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nB1 then
                       begin B1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nB2 then
                       begin B2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nB3 then
                       begin B3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nG1 then
                       begin G1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nG2 then
                       begin G2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nG3 then
                       begin G3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nP1 then
                       begin P1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nP2 then
                       begin P2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nP3 then
                       begin P3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nN1 then
                       begin N1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nN2 then
                       begin N2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nN3 then
                       begin N3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nL1 then
                       begin L1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nL2 then
                       begin L2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nL3 then
                       begin L3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nT1 then
                       begin T1 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nT2 then
                       begin T2 := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nT3 then
                       begin T3 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nC1 then
                       begin C1 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nt4 then
                       begin t4 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nP4 then
                       begin P4 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = no4 then
                       begin o4 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nK4 then
                       begin K4 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nD4 then
                       begin D4 := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do if i = nIe then
                       begin Ie := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nIk then
                       begin Ik := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nIy then
                       begin Iy := letused[i,1] ; letused[i,2] := 'y'; end;
  for i:=1 to 26 do if i = nSt then
                       begin St := letused[i,1] ; letused[i,2] := 'y'; end;

  for i:=1 to 26 do defvar[i] := '';
    for i:=1 to ns do
     begin
      for j := 1 to 26 do
       begin
         if (letused[j,2] = 'n') and (defvar[i] = '')
             then begin defvar[i] := letused[j,1]; letused[j,2] := 'y' end;
       end;
     end;

end;



PROCEDURE feedback;
Begin
    if measurement = 'y' then
    writeln(ouf,'! Measurement part subject variables is used')
       else writeln(ouf,'! Measurement part subjects variables is not used');
    if familyvariables = 'y' then
      begin
       writeln(ouf,'! Family variables present');
       if measurementx = 'y' then writeln(ouf,'! Measurement part family variables is used')
                                 else writeln(ouf,'! Measurement part family variables is not used');
       end;
    if stratification = 'y' then
    writeln(ouf,'! Analysis controls for stratification')
        else     writeln(ouf,'! Analysis does not control for stratification');
    writeln(ouf,'! Number of subjects in largest family: ',ns);
    writeln(ouf,'! Number of subject variables: ',neta);
    if (measurement = 'y') then writeln(ouf,'! Number of indicators for subject variables: ',ny);
    if familyvariables = 'y' then writeln(ouf,'! Number of family variables: ',nksi);
    if (measurementx = 'y') then writeln(ouf,'! Number of indicators for family variables: ',nx);
    writeln(ouf,'! Number of dummy variables for genotypes: ',nd);
    if stratification = 'y' then
    writeln(ouf,'! Number of dummy variables for family types: ',nm);
end;

PROCEDURE group1_3;
Begin
    writeln(ouf,'');
    writeln(ouf,'Group 1: General part subject variables');
    if familyvariables = 'y' then writeln(ouf,'Calculation ng=5')
                             else writeln(ouf,'Calculation ng=4') ;
    writeln(ouf,'Matrices');
    writeln(ouf,' a Full ',neta:2,'  1 Fixed  ! Means subject variables; Alpha');
    if (BETA = 'y') then
     writeln(ouf,' B Full ',neta:2,' ',neta:2,' Fixed  ! Causal effects subject variables on each other; Beta');
    if (familyvariables = 'y') then
     writeln(ouf,' G Full ',neta:2,' ',nksi:2,' Fixed  ! Causal effects family on subject variables; GAMMA');
    writeln(ouf,' P Symm ',neta:2,' ',neta:2,' Fixed  ! Residual (co)variances subject variables; Psi');
if (measurement = 'y') then
 begin
    writeln(ouf,' v Full ',ny:2,'  1 Fixed  ! Intercepts subject indicators; Nu');
    writeln(ouf,' L Full ',ny:2,' ',neta:2,' Fixed  ! Factor loadings subject indicators; Lambda');
    writeln(ouf,' T Symm ',ny:2,' ',ny:2,' Fixed  ! Measurement errors subject indicators; Theta');
 end;

if ns > 1 then
   begin
    if measurement = 'y' then writeln(ouf,' C Symm ',ny:2,' ',ny:2,' Free   ! Covariances between family members; C');
    if measurement <> 'y' then writeln(ouf,' C Symm ',neta:2,' ',neta:2,' Free   ! Covariances between family members; C');
   end;
    writeln(ouf,'End Matrices');
    writeln(ouf,'Matrix a             ! specify (starting) values for (free) parameters');
    for i := 1 to neta do writeln(ouf,' 0.0');
    if (BETA = 'y') then
     begin
      writeln(ouf,'Matrix B             ! (starting) values: Main diagonal B should ALWAYS remain zero ');
     for i := 1 to neta do
      begin
       for j := 1 to neta do if i = j then write(ouf,'  0 ') else write(ouf,' 0.0');
       writeln(ouf);
      end;
    end;
    writeln(ouf,'Matrix P             ! (starting) values');
     for i := 1 to neta do
      begin
       for j := 1 to neta do if i >= j then write(ouf,' 0.0');
       writeln(ouf);
      end;

if (measurement = 'y') then
 begin
    writeln(ouf,'Matrix v             ! (starting) values');
    for i := 1 to ny do writeln(ouf,' 0.0');
    writeln(ouf,'Matrix L             ! (starting) values');
     for i := 1 to ny do
      begin
       for j := 1 to neta do write(ouf,' 0.0');
       writeln(ouf);
      end;
    writeln(ouf,'Matrix T             ! (starting) values');
     for i := 1 to ny do
      begin
       for j := 1 to ny do if i >= j then write(ouf,' 0.0');
       writeln(ouf);
      end;


 end;
if ns > 1 then
   begin
    if measurement = 'y' then
      begin
      writeln(ouf,'Matrix C             !  starting  values');
     for i := 1 to ny do
      begin
       for j := 1 to ny do if i >= j then write(ouf,' 0.0');
       writeln(ouf);
      end;
    end;
    if measurement <> 'y' then
      begin
      writeln(ouf,'Matrix C             !  starting  values');
     for i := 1 to neta do
      begin
       for j := 1 to neta do if i >= j then write(ouf,' 0.0');
       writeln(ouf);
      end;
    end;
   end;

    writeln(ouf,'Output');
    writeln(ouf,'');

    writeln(ouf,'Group 2: Genetic effects');
    writeln(ouf,'Calculation');
    writeln(ouf,'Matrices');
if (gALPHA = 'y') then
    begin
    write(ouf,' A Full ',neta:2,' ',nd:2,' Fixed');
    writeln(ouf,'  ! Means; Alpha = ',nd,' horizontally stacked ',neta,' x 1 subvectors');
    end;
if (gBETA = 'y') then
    begin
    write(ouf,' B Full ',neta:2,' ',nd*neta:2,' Fixed');
    writeln(ouf,'  ! Causal effects; Beta = ',nd,' stacked ',neta,' x ',neta,' submatrices');
    end;
if (gGAMMA = 'y') then
    begin
    write(ouf,' G Full ',neta:2,' ',nd*nksi:2,' Fixed');
    writeln(ouf,'  ! Causal effects family variables; Gamma = ',nd,' stacked ',neta,' x ',nksi,' submatrices');
    end;
if (gPSI = 'y') then
    begin
    write(ouf,' P Full ',neta:2,' ',nd*neta:2,' Fixed');
    writeln(ouf,'  ! Residual (co)variances; Psi = ',nd,' stacked ',neta,' x ',neta,' submatrices');
    end;

if (measurement = 'y') then
 begin
if (gNU = 'y') then
    begin
    write(ouf,' N Full ',ny:2,' ',nd:2,' Fixed');
    writeln(ouf,'  ! Intercepts; Nu = ',nd,' stacked ',ny,' x 1 subvectors');
    end;

if (gLAMBDA = 'y') then
    begin
    write(ouf,' L Full ',ny:2,' ',nd*neta:2,' Fixed');
    writeln(ouf,'  ! Factor loadings; Lamda =  ',nd,' stacked ',ny,' x ',neta,' submatrices');
    end;

if (gTheta = 'y') then
    begin
    write(ouf,' T Full ',ny:2,' ',nd*ny:2,' Fixed');
    writeln(ouf,'  ! Measurement errors; Theta =  ',nd,' stacked ',ny,' x ',ny,' submatrices');
    end;
 end;
    writeln(ouf,'End Matrices');
    writeln(ouf,'Output');
    writeln(ouf,'');

    writeln(ouf,'Group 3: Stratification effects on subject variables');
    writeln(ouf,'Calculation');
    writeln(ouf,'Matrices');

if (stratification = 'y') then
 Begin
if (sALPHA = 'y') then
    begin
    write(ouf,' A Full ',neta:2,' ',nm:2,' Fixed');
    writeln(ouf,'  ! Means; Alpha = ',nm,' horizontally stacked ',neta,' x 1 subvectors');
    end;
if (sBETA = 'y') then
    begin
    write(ouf,' B Full ',neta:2,' ',nm*neta:2,' Fixed');
    writeln(ouf,'  ! Causal effects; Beta = ',nm,' stacked ',neta,' x ',neta,' submatrices');
    end;
if (sGAMMA = 'y') then
    begin
    write(ouf,' G Full ',neta:2,' ',nm*nksi:2,' Fixed');
    writeln(ouf,'  ! Causal effects family variables; Gamma = ',nm,' stacked ',neta,' x ',nksi,' submatrices');
    end;
if (sPSI = 'y') then
    begin
    write(ouf,' P Full ',neta:2,' ',nm*neta:2,' Fixed');
    writeln(ouf,'  ! Residual (co)variances; Psi = ',nm,' stacked ',neta,' x ',neta,' submatrices');
    end;

if (measurement = 'y') then
 begin
if (sNU = 'y') then
    begin
    write(ouf,' N Full ',ny:2,' ',nm:2,' Fixed');
    writeln(ouf,'  ! Intercepts; Nu = ',nm,' stacked ',ny,' x 1 subvectors');
    end;

if (sLAMBDA = 'y') then
    begin
    write(ouf,' L Full ',ny:2,' ',nm*neta:2,' Fixed');
    writeln(ouf,'  ! Factor loadings; Lambda =  ',nm,' stacked ',ny,' x ',neta,' submatrices');
    end;

if (sTheta = 'y') then
    begin
    write(ouf,' T Full ',ny:2,' ',nm*ny:2,' Fixed');
    writeln(ouf,'  ! Measurement errors; Theta =  ',nm,' stacked ',ny,' x ',ny,' submatrices');
    end;

 end;
 End;
    writeln(ouf,'End Matrices');
    writeln(ouf,'Output');
    writeln(ouf,'');
End;

PROCEDURE group4;
Begin
    writeln(ouf,'Group 4: Family variables');
    writeln(ouf,'Calculation');
    writeln(ouf,'Matrices');
    writeln(ouf,' t Full ',nksi:2,'  1 Fixed  ! Means family variables; Tau');
    writeln(ouf,' P Symm ',nksi:2,' ',nksi:2,' Fixed  ! (Co)Variances family variables; Phi');
    writeln(ouf,' o Full ',nx:2,'  1 Free   ! Intercepts family indicators; Omicron');
    if (measurementx = 'y') then
    begin
     writeln(ouf,' K Full ',nx:2,' ',nksi:2,' Fixed  ! Factor loadings family indicators; Kappa');
     writeln(ouf,' D Symm ',nx:2,' ',nx:2,' Fixed  ! Measurement errors family indicators; Delta');
    end;
    writeln(ouf,'End Matrices');
    writeln(ouf,'Matrix t             ! (starting) values');
      for i := 1 to nksi do writeln(ouf,' 0.0');
    writeln(ouf,'Matrix P             ! (starting) values');
    for i := 1 to nksi do
      begin
       for j := 1 to nksi do if i >= j then write(ouf,' 0.0');
       writeln(ouf);
      end;
      writeln(ouf,'Matrix o             ! (starting) values');
      for i := 1 to nx do writeln(ouf,' 0.0');
    if (measurementx = 'y') then
    begin
      writeln(ouf,'Matrix K             ! (starting) values');
       for i := 1 to nx do
         begin
          for j := 1 to nksi do write(ouf,' 0.0');
          writeln(ouf);
         end;
     writeln(ouf,'Matrix D             ! (starting) values');
     for i := 1 to nx do
      begin
       for j := 1 to nx do if i >= j then write(ouf,' 0.0');
       writeln(ouf);
      end;
    end;
    writeln(ouf,'Output');
End;

PROCEDURE datagroup;
BEGIN
{data group}

    writeln(ouf);
    if familyvariables = 'y' then writeln(ouf,'Group 5: Fit model to data')
                             else writeln(ouf,'Group 4: Fit model to data');

    writeln(ouf,'Data NInput=',nx+ns*(ny+nd)+nm);
    writeln(ouf,'Rectangular File=',datname);
    writeln(ouf,'Labels');

    for j:=1 to nx do begin write(ouf,' '); write(ouf,'X',j); end;
    if (stratification = 'y') then
      begin
       write(ouf,' ');
       for i:=1 to (nm) do write(ouf,'F',i,' ');
       writeln(ouf);
      end ;


    for i:=1 to ns do
     begin
      write(ouf,' ');
      for j:=1 to (ny) do write(ouf,'Y',j,'_',i,' ');
      for j:=1 to (nd) do write(ouf,'G',j,'_',i,' ');
      writeln(ouf);
     end;

    writeln(ouf,'Definition');
     if (stratification = 'y') then
      begin
      write(ouf,' ');
       for i:=1 to (nm) do write(ouf,'F',i,' ');
       writeln(ouf);
      end;
    for i:=1 to ns do
     begin
      write(ouf,' ');
      for j:=1 to (nd) do write(ouf,'G',j,'_',i,' ');
      if (i=ns) then writeln(ouf,'/') else writeln(ouf);
     end;

    writeln(ouf,'Matrices');

                              writeln(ouf,' ',A1,' Full ',neta:2,'  1 =a1');
    if (gALPHA = 'y') then    writeln(ouf,' ',A2,' Full ',neta:2,' ',nd:2,' =A2');
    if (sALPHA = 'y') then    writeln(ouf,' ',A3,' Full ',neta:2,' ',nm:2,' =A3');

    if (BETA = 'y') then      writeln(ouf,' ',B1,' Full ',neta:2,' ',neta:2,' =B1');
    if (gBETA = 'y') then     writeln(ouf,' ',B2,' Full ',neta:2,' ',nd*neta:2,' =B2');
    if (sBETA = 'y') then     writeln(ouf,' ',B3,' Full ',neta:2,' ',nm*neta:2,' =B3');

    if (familyvariables  = 'y')
                      then    writeln(ouf,' ',G1,' Full ',neta:2,' ',nksi:2,' =G1');
    if (gGAMMA = 'y') then    writeln(ouf,' ',G2,' Full ',neta:2,' ',nd*nksi:2,' =G2');
    if (sGAMMA = 'y') then    writeln(ouf,' ',G3,' Full ',neta:2,' ',nm*nksi:2,' =G3');

                              writeln(ouf,' ',P1,' Symm ',neta:2,' ',neta:2,' =P1');
    if (gPSI = 'y') then      writeln(ouf,' ',P2,' Full ',neta:2,' ',nd*neta:2,' =P2');
    if (sPSI = 'y') then      writeln(ouf,' ',P3,' Full ',neta:2,' ',nm*neta:2,' =P3');

    if (measurement = 'y') then
                              writeln(ouf,' ',N1,' Full ',ny:2,'  1 =v1');
    if (gNU = 'y') then       writeln(ouf,' ',N2,' Full ',ny:2,' ',nd:2,' =N2');
    if (sNU = 'y') then       writeln(ouf,' ',N3,' Full ',ny:2,' ',nm:2,' =N3');

    if (measurement = 'y') then
                              writeln(ouf,' ',L1,' Full ',ny:2,' ',neta:2,' =L1');
    if (gLAMBDA = 'y') then   writeln(ouf,' ',L2,' Full ',ny:2,' ',nd*neta:2,' =L2');
    if (sLAMBDA = 'y') then   writeln(ouf,' ',L3,' Full ',ny:2,' ',nm*neta:2,' =L3');

    if (measurement = 'y') then
                              writeln(ouf,' ',T1,' Symm ',ny:2,' ',ny:2,' =T1');
    if (gTheta = 'y') then    writeln(ouf,' ',T2,' Full ',ny:2,' ',nd*ny:2,' =T2');
    if (sTheta = 'y') then    writeln(ouf,' ',T3,' Full ',ny:2,' ',nm*ny:2,' =T3');


    if (ns > 1)       then    writeln(ouf,' ',C1,' Symm ',ny:2,' ',ny:2,' =C1');

    if (fammean = 'y')
                     then      writeln(ouf,' ',t4,' Symm ',nksi:2,'  1 =t4');

    if (familyvariables = 'y')
                     then      writeln(ouf,' ',P4,' Symm ',nksi:2,' ',nksi:2,' =P4');

    if (familyvariables = 'y') then
                              writeln(ouf,' ',o4,' Full ',nx:2,'  1 =o4');

    if (measurementx = 'y') then
                              writeln(ouf,' ',K4,' Full ',nx:2,' ',nksi:2,' =K4');

    if (measurementx = 'y') then
                              writeln(ouf,' ',D4,' Symm ',nx:2,' ',nx:2,' =D4');

    if (neta > 1) and
      ((BETA = 'y') or (gPSI='y') or (sPSI='y') or
       (gLAMBDA= 'y') or (sLAMBDA= 'y')) then
                              writeln(ouf,' ',Ie,' Iden ',neta:2,' ',neta:2,'    ! identity matrix subject variables');
    if (nksi > 1) and
       ((gGAMMA = 'y') or (sGAMMA='y')) then
                              writeln(ouf,' ',Ik,' Iden ',nksi:2,' ',nksi:2,'    ! identity matrix family variables');
    if (ny > 1) and
       ((sTheta = 'y') OR (gTheta = 'y'))
                         then writeln(ouf,' ',Iy,' Iden ',ny:2,' ',ny:2,'    ! identity matrix indicators subject variables');

    if (stratification = 'y')  then writeln(ouf,' ',St,' Full ',nm:2,'  1    ! family type dummy variables');

    for i:=1 to ns do
        writeln(ouf,' ',defvar[i],' Full ',nd:2,'  1    ! genetic dummy variables subject ',i);


 for  i := 1 to ns do
 begin

{ main model}
  a[i] := A1;
  B[i] := B1;
  G[i] := G1;
  P[i] := P1;
  v[i] := N1;
  L[i] := L1;
  T[i] := T1;

  C[i] := C1;

  tau := t4;
  Ph := P4;
  Om := o4;
  Ka := K4;
  De := D4;

  if (gALPHA = 'y')  then a[i]:= concat(a[i],'+',A2,'*',defvar[i]);
  if (gNU = 'y')     then v[i]:= concat(v[i],'+',N2,'*',defvar[i]);

  if (sALPHA = 'y')  then a[i]:= concat(a[i],'+',A3,'*',St);
  if (sNU = 'y')     then v[i]:= concat(v[i],'+',N3,'*',St);



if neta > 1 then
  begin
  if (gBETA = 'y')   then B[i]:= concat(B[i],'+',B2,'*(',defvar[i],'@',Ie,')');
  if (gPSI = 'y')    then P[i]:= concat(P[i],'+',P2,'*(',defvar[i],'@',Ie,')');
  if (gLAMBDA = 'y') then L[i]:= concat(L[i],'+',L2,'*(',defvar[i],'@',Ie,')');
  if (sBETA = 'y')   then B[i]:= concat(B[i],'+',B3,'*(',St,'@',Ie,')');
  if (sPSI = 'y')    then P[i]:= concat(P[i],'+',P3,'*(',St,'@',Ie,')');
  if (sLAMBDA = 'y') then L[i]:= concat(L[i],'+',L3,'*(',St,'@',Ie,')');
 end;

if neta = 1 then
  begin
  if (gBETA = 'y')   then B[i]:= concat(B[i],'+',B2,'*(',defvar[i],')');
  if (gPSI = 'y')    then P[i]:= concat(P[i],'+',P2,'*(',defvar[i],')');
  if (gLAMBDA = 'y') then L[i]:= concat(L[i],'+',L2,'*(',defvar[i],')');
  if (sBETA = 'y')   then B[i]:= concat(B[i],'+',B3,'*(',St,')');
  if (sPSI = 'y')    then P[i]:= concat(P[i],'+',P3,'*(',St,')');
  if (sLAMBDA = 'y') then L[i]:= concat(L[i],'+',L3,'*(',St,')');
 end;

if nksi > 1 then
  begin
   if (gGAMMA = 'y')  then G[i]:= concat(G[i],'+',G2,'*(',defvar[i],'@',Ik,')');
   if (sGAMMA = 'y')  then G[i]:= concat(G[i],'+',G3,'*(',St,'@',Ik,')');
  end;

if nksi = 1 then
  begin
   if (gGAMMA = 'y')  then G[i]:= concat(G[i],'+',G2,'*(',defvar[i],')');
   if (sGAMMA = 'y')  then G[i]:= concat(G[i],'+',G3,'*(',St,')');
  end;

if ny > 1 then
 begin
 if (gTheta = 'y')  then T[i]:= concat(T[i],'+',T2,'*(',defvar[i],'@',Iy,')');
 if (sTheta = 'y')  then T[i]:= concat(T[i],'+',T3,'*(',St,'@',Iy,')');
 end;

if ny = 1 then
 begin
 if (gTheta = 'y')  then T[i]:= concat(T[i],'+',T2,'*(',defvar[i],')');
 if (sTheta = 'y')  then T[i]:= concat(T[i],'+',T3,'*(',St,')');
 end;


                               Sx := Ph;
  if (measurementx = 'y') then Sx := concat('(',Ka,')*(',Ph,')*(',Ka,')''',' + (',De,')');

                               Syx[i] := concat('(',G[i],')*(',Ph,')');
  if (measurementx = 'y') then Syx[i] := concat(Syx[i],'*(',Ka,')''');
  if (Beta = 'y')         then Syx[i] := concat('(',Ie,'-(',B[i],'))~*',Syx[i]);
  if (measurement = 'y')  then Syx[i] := concat('(',L[i],')*',Syx[i]);

                               Sxy[i] := concat('(',Ph,')*(',G[i],')''');
  if (measurementx = 'y') then Sxy[i] := concat('(',Ka,')*',Sxy[i]);
  if (Beta = 'y')         then Sxy[i] := concat(Sxy[i],'*((',Ie,'-(',B[i],'))~)''');
  if (measurement = 'y')  then Sxy[i] := concat(Sxy[i],'*(',L[i],')''');


                               a[i] := concat('(',a[i],')');
  if BETA = 'y' then          Bt[i] := concat('*((',Ie,'-(',B[i],'))~)''') else Bt[i] := '';
  if BETA = 'y' then           B[i] := concat('(',Ie,'-(',B[i],'))~*') else B[i] := '';
                               P[i] := concat('(',P[i],')');
 if familyvariables = 'y' then P[i] := concat('((',G[i],')*(',Ph,')*(',G[i],')''',' + ',P[i],')');
  if (measurement = 'y') then  v[i] := concat('(',v[i],') + ') else v[i] := '';
  if (measurement = 'y') then  Lt[i]:= concat('*(',L[i],')''') else Lt[i] := '';
  if (measurement = 'y') then  L[i] := concat('(',L[i],')*') else L[i] := '';
  if (measurement = 'y') then  T[i] := concat(' + (',T[i],')') else T[i] := '';
  if (ns > 1)            then  C[i] := concat('(',C[i],')');




end;

  writeln(ouf,'End Matrices');
  writeln(ouf,'Means');
  if familyvariables = 'y' then
   begin
    if ((fammean = 'y') and (measurementX = 'y')) then writeln(ouf,'  ',Om,'+',Ka,'*',tau,' _        ! mean family variables')
      else if ((fammean = 'y') and (measurementx <> 'y')) then writeln(ouf,'  ',Om,'+',tau,' _        ! mean family variables')
       else writeln(ouf,'  ',Om,' _        ! mean family variables');
   end;
  for i := 1 to ns do
    if fammean = 'y' then
    begin
      write(ouf,' ');
      if i = ns then writeln(ouf,v[i],L[i],B[i],'(',a[i],'+(',G[i],')*',tau,') /     ! mean subject ',i)
        else writeln(ouf,v[i],L[i],B[i],'(',a[i],'+(',G[i],')*',tau,') _     ! mean subject ',i);
     end else
    begin
      write(ouf,' ');
      if i = ns then writeln(ouf,v[i],L[i],B[i],a[i],' /     ! mean subject ',i)
        else writeln(ouf,v[i],L[i],B[i],a[i],' _     ! mean subject ',i);
     end;


    

  writeln(ouf,'Covariances');
   if familyvariables = 'y' then
      begin
       write(ouf,' ',Sx,' | ');
       for i := 1 to ns do
           if i < ns then write(ouf,Sxy[i],' | ')
           else writeln(ouf,Sxy[i],' _       ! family variables ');
      end;

  for i := 1 to ns do
   begin
   write(ouf,' ');
   if familyvariables = 'y' then write(ouf,Syx[i],' | ');
    for j := 1 to ns do
     begin
     if (i=j) and (i < ns) then write(ouf,L[i],B[i],P[i],Bt[i],Lt[i],T[i],' | ');
     if (i=j) and (i = ns) then writeln(ouf,L[i],B[i],P[i],Bt[i],Lt[i],T[i],' / ! variance subject ',i);
     if (j <> i) and (j<ns) then write(ouf,C[i],' | ');
     if (j <> i) and (j=ns) then writeln(ouf,C[i],' _ ! variance subject ',i);
     end;
    end;

    if (stratification = 'y') then
     begin
       writeln(ouf,'Specify ',St);
       write(ouf,' ');
       for i:=1 to (nm) do write(ouf,'F',i,' ');
       writeln(ouf);
      end;
    for i:=1 to ns do
     begin
      writeln(ouf,'Specify ',defvar[i]);
      write(ouf,' ');
      for j:=1 to (nd) do write(ouf,'G',j,'_',i,' ');
      writeln(ouf);
     end;

  writeln(ouf,'Options');
  writeln(ouf,'End');
END;


BEGIN
   batchname := ParamStr(1);
   fileExists(batchname);
   {batchname := 'input.dat';}
   assign(batch,batchname); reset(batch) ;
   if batchname = '' then questions else readbatch;
   letter2matrix;
   assign(ouf,outname); rewrite (ouf) ;
   feedback;
   group1_3;
   if familyvariables = 'y' then group4;
   datagroup;
   close(ouf);
END.
